//+------------------------------------------------------------------+
//|                                                                  |
//|                 Copyright  1999-2007, MetaQuotes Software Corp. |
//|                                         http://www.metaquotes.ru |
//+------------------------------------------------------------------+

#property copyright "cloud"
#property link "http://cloud666.rbcmail.ru"

extern double MaxLot=0.1;   //maximalni velikost lotu
extern double TrailingStop=0.0020;
extern double StopLoss=0.0020;
extern int    Slippage=0.0; //maximalni slippage
extern int Condition1=1;
extern int Condition2=1;
extern double LotSpliter=1.0;

extern double prah_vetsi=1.5;
extern double prah_mensi=0.1;
extern double prah_buy=0.5;
int timeStop=600; //deset minut

double Lot=0.5; //maximalni lot
double PP=0;
double slu,sld,a,b;
double tp,sl;
int fileHandle;
string nameData="EAlog.log";
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   logIt("Strategie sputna");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   logIt("Strategie ukonena");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   logIt("Start falling star");
 //  if(AccountServer()!="" || AccountNumber()!=0){logIt("Account server or Account number failure."); return(0);}
   if(OrdersTotal()==0)
     {
      logIt("Orders total=0");
      PP=0;
      Lot=NormalizeDouble(MathFloor(LotSpliter*AccountBalance()*AccountLeverage()/Ask/MarketInfo(Symbol(),MODE_LOTSIZE)*10)/10,1);
      if(MaxLot>0 && Lot>MaxLot){Lot=MaxLot;}
      if(Lot>MarketInfo(Symbol(),25)){Lot=MarketInfo(Symbol(),25);}
      if(StopLoss<(MarketInfo(Symbol(),MODE_STOPLEVEL)/MathPow(10,Digits)))  //pokud je stopplos mensi nez je povoleno nastavi min. co je povoleno
        {
         StopLoss=MarketInfo(Symbol(),MODE_STOPLEVEL)/MathPow(10,Digits);
        }
      U();
      return(0);
     }
   if(OrdersTotal()==1)
     {
      OrderSelect(0,SELECT_BY_POS,MODE_TRADES); 
 
      if(TimeCurrent()-OrderOpenTime()<timeStop) OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),Slippage,Yellow);
 
      if((OrderType()==OP_BUY)&&(OrderStopLoss()<(Bid-TrailingStop))&&(TrailingStop!=0))
              {
               OrderModify(OrderTicket(), 0, Bid-TrailingStop, 0, 0, 0);
              }
  
      if((OrderType()==OP_SELL)&&(OrderStopLoss()>(Ask+TrailingStop))&&(TrailingStop!=0))
              {
               OrderModify(OrderTicket(), 0, Ask+TrailingStop, 0, 0, 0);
              }

          }
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| obchodni fce             |
//+------------------------------------------------------------------+
int U()
  {
   double telo= MathAbs(Open[1]-Close[1]);
   double knothorni=High[1]-MathMax(Open[1],Close[1]);
   double knotdolni=-Low[1]+MathMin(Open[1],Close[1]);
   
   int res;  
   double otevritza;
   if (knothorni>prah_vetsi*telo  && knotdolni<prah_mensi*telo  && Condition1==1)
     {  
      otevritza=MathMax(Open[1],Close[1])+knothorni*prah_buy;
      res=OrderSend(Symbol(), OP_SELLLIMIT, NormalizeDouble(Lot,1), NormalizeDouble(otevritza,4), Slippage,
      NormalizeDouble(otevritza+StopLoss,4), 0, 0, 1001002,  0, Red);
  
      res=OrderSend(Symbol(), OP_SELLLIMIT, NormalizeDouble(Lot,1), NormalizeDouble(otevritza,4), Slippage,
      0, 0, 0, 1001002,  0, Red);
  
      return(res);
     }
     
   if (knotdolni>prah_vetsi*telo  && knothorni<prah_mensi*telo  && Condition2==1) 
     {  
      otevritza=MathMin(Open[1],Close[1])-knothorni*prah_buy;
      res=OrderSend(Symbol(), OP_BUYLIMIT, NormalizeDouble(Lot,1), NormalizeDouble(otevritza,4), Slippage,
      NormalizeDouble(otevritza-StopLoss,4), 0, 0, 1001001, 0, Green);

  

      return(res);
     }

   return(0);
  }


//+------------------------------------------------------------------+
//| logovaci fce                                |
//+------------------------------------------------------------------+
int logIt(string message)
  {
//----
   fileHandle = FileOpen(nameData,FILE_READ|FILE_WRITE );
   if(fileHandle < 1)
     {
       Alert("Failed creating "+nameData+". Error #", GetLastError());
       return(0);
      }
   FileSeek(fileHandle, 0, SEEK_END);   
   FileWrite(fileHandle,TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS) +":  " + message);                  // header   
   FileClose(fileHandle);
   return (1);
 
//----
  }